* PROCEDURE GRMVGRP

* Removes group bands from the report if the first parameter is .F.

PARAMETER PSUB, PGRP

* PSUB - Do we want subtotals for the group
* PGRP - The group expression; what the group breaks on.

IF PSUB
  RETURN
ENDIF

PGRP = UPPER(PGRP)

* Make sure that the group realy exists
LOCATE FOR OBJTYPE = 9 AND OBJCODE = 3 AND UPPER(EXPR) = PGRP
IF !FOUND()
  WAIT WINDOW "Report group not found: "+PGRP
  RETURN
ENDIF

* Count the number of groups in the report. (count the headers)
COUNT FOR OBJTYPE=9 AND OBJCODE=3 TO XGRPCNT

* Find the level of the group that we are removing.
LOCATE FOR OBJTYPE=9 AND OBJCODE=3 
COUNT TO XGRPRMV WHILE UPPER(EXPR) <> PGRP
* Bump, cuz the first level will return 0....
XGRPRMV = XGRPRMV + 1

* Find the start and height of group header and footer

* The start is the sum of all heights above it:
LOCATE
SUM HEIGHT TO XHEDPOS FOR OBJTYPE = 9 AND OBJCODE <= 3 WHILE UPPER(EXPR) <> PGRP

* We are on the groups header reccord, get the hight of the header
XHEDHGT = HEIGHT

* and delete the header band
DELETE

* Find first group footer, then skip to the footer we are looking for.
LOCATE FOR OBJTYPE = 9 AND OBJCODE = 5
SKIP XGRPCNT - XGRPRMV

* We should now be on the groups footer.
XRECNO = RECNO()
* so get the hight of the footer, then delete it
XFOTHGT = HEIGHT
DELETE

* Find the start of group footer
* The start is the sum of all heights above it:
LOCATE
SUM HEIGHT TO XFOTPOS FOR OBJTYPE = 9 WHILE RECNO() <> XRECNO

* Delete all objects in the group header
DELETE FOR INLIST( OBJTYPE, 5, 8 ) AND BETWEEN(VPOS, XHEDPOS, XHEDPOS + XHEDHGT-1 )

* Delete all objects in the group footer
DELETE FOR INLIST( OBJTYPE, 5, 8 ) AND BETWEEN(VPOS, XFOTPOS, XFOTPOS + XFOTHGT-1 )

* NOW THE BIGGIE!!!

* Move all the objects in rows after the header up the size of the header
REPLACE VPOS WITH VPOS - XHEDHGT;
 FOR INLIST( OBJTYPE, 5, 8 ) AND VPOS >= XHEDPOS

* Move all the objects in rows after the footer up the size of the footer
* hmm, now the begining of the footer has just been moved up by the previous
* line.  so take that into account (XHEDHGT).
REPLACE VPOS WITH VPOS - XFOTHGT;
 FOR INLIST( OBJTYPE, 5, 8 ) AND VPOS >= XFOTPOS-XHEDHGT

* Delete any variables that relied on the band we are removing.
* this will cause an error if any other vars reference them, which
* would cause unknown results.  maby it would work anyway, but for now
* I (carl) think it would be bad.

* the above notes are wrong!  if you take out the vars that get reset on
* the group that we are removing, there may be stactic vars (total type none)
* that referance them that will be sad if they are not there.

* DELETE FOR OBJTYPE=18 AND RESETTOTAL-2=XGRPRMV

* Move up a level all resettotals that were on inner groups:
REPLACE RESETTOTAL WITH RESETTOTAL-1;
 FOR RESETTOTAL-2 >= XGRPRMV

PACK

RETURN
* EOP: GRMVGRP *
